/****************************************************************************
**
** Copyright (C) 2003-2007 Trolltech ASA. All rights reserved.
**
** This file is part of a Qt Solutions component.
**
** This file may be used under the terms of the GNU General Public
** License version 2.0 as published by the Free Software Foundation
** and appearing in the file LICENSE.GPL included in the packaging of
** this file.  Please review the following information to ensure GNU
** General Public Licensing requirements will be met:
** http://www.trolltech.com/products/qt/opensource.html
**
** If you are unsure which license is appropriate for your use, please
** review the following information:
** http://www.trolltech.com/products/qt/licensing.html or contact the
** Trolltech sales department at sales@trolltech.com.
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
****************************************************************************/
#ifndef QTSPELLCHECKINGTEXTEDIT_H
#define QTSPELLCHECKINGTEXTEDIT_H

#include <QtGui/QTextEdit>

#if defined(Q_WS_WIN)
#  if !defined(QT_QTSPELLCHECKINGTEXTEDIT_EXPORT) && !defined(QT_QTSPELLCHECKINGTEXTEDIT_IMPORT)
#    define QT_QTSPELLCHECKINGTEXTEDIT_EXPORT
#  elif defined(QT_QTSPELLCHECKINGTEXTEDIT_IMPORT)
#    if defined(QT_QTSPELLCHECKINGTEXTEDIT_EXPORT)
#      undef QT_QTSPELLCHECKINGTEXTEDIT_EXPORT
#    endif
#    define QT_QTSPELLCHECKINGTEXTEDIT_EXPORT __declspec(dllimport)
#  elif defined(QT_QTSPELLCHECKINGTEXTEDIT_EXPORT)
#    undef QT_QTSPELLCHECKINGTEXTEDIT_EXPORT
#    define QT_QTSPELLCHECKINGTEXTEDIT_EXPORT __declspec(dllexport)
#  endif
#else
#  define QT_QTSPELLCHECKINGTEXTEDIT_EXPORT
#endif

class QAction;
class QtSpellCheckHighlighter;
class QT_QTSPELLCHECKINGTEXTEDIT_EXPORT QtSpellCheckingTextEdit: public QTextEdit
{
Q_OBJECT
public:
    QtSpellCheckingTextEdit(QWidget* parent = 0);
    QtSpellCheckingTextEdit(const QString & text, QWidget * parent = 0);
protected:
    void contextMenuEvent(QContextMenuEvent * e);
private Q_SLOTS:
    void suggestedWordSelected(QAction *action);
private:
    void toggleSyntaxHighlighting();
    void spotlight(const QString &word);
    void openPanel(const QString &word);
    void init();
    QTextCursor checkedTextCursor;
    QString currentWord;
    QtSpellCheckHighlighter *syntaxhighlighter;

    QAction *ignoreSpellingAction;
    QAction *learnSpellingAction;

    QAction *lookupSpotlightAction;
    QAction *lookupGoogleAction;

    QAction *cutAction;
    QAction *copyAction;
    QAction *pasteAction;

    QAction *spellingPanelAction;
    QAction *asYouTypeAction;
};

#endif
